from django.shortcuts import get_object_or_404,render
from energie.models import Voda
from datetime import datetime, timedelta

# Create your views here.

def voda_index(request):
    rows = Voda.objects.all()
    context = {
        'voda' : rows
    }
    return render(request,'voda/index.html',context)

def voda_detail(request,id):
    row = get_object_or_404(Voda,id = id)
    context = {
        'voda' : row
    }
    return render(request,'voda/detail.html',context)

def voda_add(request):
    if request.method == 'POST':
        if request.POST.get('datum') and request.POST.get('spotreba'):
            v = Voda()
            v.datum = request.POST.get('datum')
            v.spotreba = request.POST.get('spotreba')
            v.rozdiel_spotreby = float(v.spotreba) - float(request.POST.get('predosla_spotreba'))
            d1 = datetime.strptime(v.datum,"%Y-%m-%d")
            d2 = datetime.strptime(request.POST.get('predosly_datum'),"%Y-%m-%d")
            days = (d1 - d2).days
            if days > 0:
                if v.rozdiel_spotreby > 0:
                    v.denna_spotreba = v.rozdiel_spotreby / days
                else:
                    context = {
                        'status' : {'id':1,'text':'Zadal si nižšiu, resp. rovnakú spotrebu ako predošlá spotreba!'}
                    }
                    return render(request,'voda/status.html',context)  
            else:
                context = {
                    'status' : {'id':1,'text':'Zadal si starší, resp. rovnaký dátum!'}
                }
                return render(request,'voda/status.html',context)
            v.save()
            context = {
                'status' : {'id':0,'text':'Nový záznam bol úspešne pridaný.'}
            }
            return render(request,'voda/status.html',context)
        context = {
            'status' : {'id':1,'text':'Nezadal si potrebné údaje!'}
        }
        return render(request,'voda/status.html',context)
    else:
        if Voda.objects.all().first():
            max_datum = Voda.objects.latest('datum').datum
            row = Voda.objects.get(datum = max_datum)
            context = {
                'v' : row
            }
            return render(request,'voda/add.html',context)
        else:
            yesterday = datetime.now() - timedelta(days = 1)
            context = {
                'v' : {'datum':yesterday.date(),'spotreba':0,'rozdiel_spotreby':0,'denna_spotreba':0}
            }
            return render(request,'voda/add.html',context)

def voda_del(request,id):
    if request.method == 'POST':
        if 'del_yes' in request.POST:
            Voda.objects.filter(id = id).delete()
            context = {
                'status' : {'id':0,'text':'Záznam bol úspešne zmazaný.'}
            }
        else:
            context = {
                'status' : {'id':1,'text':'Záznam nebol zmazaný!'}
            }
        return render(request,'voda/status.html',context)
    else:
        row = get_object_or_404(Voda,id = id)
        context = {
            'voda' : row
        }
        return render(request,'voda/del.html',context)